# Overview

[Memcached](http://memcached.org) is a Free & open source, high-performance, distributed memory object caching system, generic in nature, but intended for use in speeding up dynamic web applications by alleviating database load.

Memcached is an in-memory key-value store for small chunks of arbitrary data (strings, objects) from results of database calls, API calls, or page rendering.

# Usage

You can deploy a memcached instance with

    juju deploy memcached

Memcached listens to port 11211 on the internal network, it is not recommended to expose memcached directly to the open internet. If you want to check that it has deployed correctly you can ssh into the unit and then check the port by hand:

    juju status memcached
    juju ssh memcached/3
    echo "stats settings" | nc localhost 11211

The "3" in this case is an example, the `juju status memcached` will show you which machine number the service is running on so you can `juju ssh` to it.

## Scale out Usage

This charm currently does not have any scale out workloads implemented

## Known Limitations and Issues

- This charm does not implement scale out functionality at this time, so `juju add-unit memcached` will not properly autoscale. This is filed as bug #[1269537](https://bugs.launchpad.net/charms/+source/memcached/+bug/1269537).

# Configuration

Standard configuration options are provided, we recommend scanning the [Memcached documentation](https://code.google.com/p/memcached/wiki/NewConfiguringServer) before tweaking the default configuration.

# Contact Information

Though this will be listed in the charm store itself don't assume a user will know that, so include that information here:

## Memcached

- [Memcached website](http://memcached.org)
- [Memcached bug tracker](https://code.google.com/p/memcached/issues/list)
- [Memcached mailing list](https://groups.google.com/forum/#!forum/memcached)